#!/usr/bin/python
# -*- coding: iso-8859-1 -*-

try:
    import wx
except ImportError:
    raise ImportError,"The wxPython module is required to run this program"


import parserXml
import Test
import Audio
import Erreur
fichierXml = parserXml.TransformXmlToPersonnes()
nouvoXml = parserXml.creerXml()
utilisateur = [ ]

nom = ' '
pwd = ' '


class simpleapp_wx(wx.Frame):

    def __init__(self,parent,id,title):
        wx.Frame.__init__(self,parent,id,title)
        self.parent = parent
        self.initialize()

    def initialize(self):
        sizer = wx.GridBagSizer()

        self.entry = wx.TextCtrl(self,-1,value=u"")
        sizer.Add(self.entry,(2,9),(2,2),wx.EXPAND)

        self.password = wx.TextCtrl(self,-1,value=u"",style=wx.TE_PASSWORD)
        sizer.Add(self.password,(5,9),(2,2),wx.EXPAND)
        

        ButtonConnexion = wx.Button(self,-1,label="Connecter")
        sizer.Add(ButtonConnexion, (11,12))
        self.Bind(wx.EVT_BUTTON, self.connexion, ButtonConnexion)

        ButtonInscription = wx.Button(self,-1,label="Inscription")
        sizer.Add(ButtonInscription,(11,11))
        self.Bind(wx.EVT_BUTTON, self.inscription, ButtonInscription)

        self.label = wx.StaticText(self,-1,label=u'Login : ')
        sizer.Add(self.label,(2,5))
        self.label.SetForegroundColour(wx.WHITE)
        
        self.label_mdp=wx.StaticText(self,-1,label=u'Mot de passe : ')
        sizer.Add(self.label_mdp,(5,5))
        self.label.SetForegroundColour(wx.WHITE)
       
        self.SetSizerAndFit(sizer)
        self.Show(True)

    def verification(self):
        return self.entry.GetValue() == u"" or self.password.GetValue() == u""
            
            

    def connexion(self,event):
        
        if(self.entry.GetValue() == u"" or self.password.GetValue()==u""):
            Erreur.message = "Veuillez remplir tous les champs"
            appli1 = wx.App()
            frame = Erreur.erreur(None,0,'Erreur')
            appli1.MainLoop()
        #wx.Frame.Destroy(self)
        elif fichierXml.nouvelleConnex(self.entry.GetValue(),self.password.GetValue()):
            Audio.nom = self.entry.GetValue()
            Audio.pwd = self.password.GetValue()
            tab = fichierXml.personneConnectee(self.entry.GetValue(),self.password.GetValue())

            r100 = Test.reglage()
            r100.freq = 100
            r100.db = float(tab.freq100)
            Test.reglages.append(r100)

            r200 = Test.reglage()
            r200.freq = 200
            r200.db = float(tab.freq200)
            Test.reglages.append(r200)
            r400 = Test.reglage()
            r400.freq = 400
            r400.db = float(tab.freq400)
            Test.reglages.append(r400)

            r800 = Test.reglage()
            r800.freq = 800
            r800.db = float(tab.freq800)
            Test.reglages.append(r800)

            r1600 = Test.reglage()
            r1600.freq = 1600
            r1600.db = float(tab.freq1600)
            Test.reglages.append(r1600)

            r3200 = Test.reglage()
            r3200.freq = 3200
            r3200.db = float(tab.freq3200)
            Test.reglages.append(r3200)

            r6400 = Test.reglage()
            r6400.freq = 6400
            r6400.db = float(tab.freq6400)
            Test.reglages.append(r6400)

            r12800 = Test.reglage()
            r12800.freq = 12800
            r12800.db = float(tab.freq12800)
            Test.reglages.append(r12800)

            r16000 = Test.reglage()
            r16000.freq = 16000
            r16000.db = float(tab.freq16000)
            Test.reglages.append(r16000)
            
            
            appli = wx.App()
            frame = Audio.audio(None,0,'Audio')
            appli.MainLoop()
        else:
                Erreur.message = "Le Login ou le password sont faux"
                appli1 = wx.App()
                frame = Erreur.erreur(None,0,'Erreur')
                appli1.MainLoop()
                 
        
    def inscription(self,event):
        if(self.entry.GetValue() == u"" or self.password.GetValue()==u""):
            Erreur.message = "Veuillez remplir tous les champs"
            appli1 = wx.App()
            frame = Erreur.erreur(None,0,'Erreur')
            appli1.MainLoop()
        elif fichierXml.rechercheNom(self.entry.GetValue()):
            
            Erreur.message = "cet utilisateur existe deja"
            appli1 = wx.App()
            frame = Erreur.erreur(None,0,'Erreur')
            appli1.MainLoop()
            
            
        else:
            #nouvoXml.ajouterPersonne(self.entry.GetValue(),self.password.GetValue())
            Test.nom = self.entry.GetValue()
            Test.pwd = self.password.GetValue()
            appli = wx.App()
            frame = Test.test(None,0,'Mon Test')
            appli.MainLoop()
            
            

   

if __name__ == "__main__":
    app = wx.App()
    frame = simpleapp_wx(None,-1,'Audioprothse V1.0')
    app.MainLoop()
