#!/usr/bin/python
# -*- coding: iso-8859-1 -*-
from pyo import *
import Test
class traitementSon():
    def __init__(self):
        self.conf=Test.reglages
        self.s=Server().boot()
        self.cor100=self.conf[0].db
        self.cor200=self.conf[1].db
        self.cor400=self.conf[2].db
        self.cor800=self.conf[3].db
        self.cor1600=self.conf[4].db
        self.cor3200=self.conf[5].db
        self.cor6400=self.conf[6].db
        self.cor12800=self.conf[7].db
        self.cor16000=self.conf[8].db



    def correct(self,sound):
        self.eq1=EQ(sound,freq=100,q=1,boost=self.correction(self.seuil(100),self.cor100),type=0)
        self.eq2=EQ(self.eq1,freq=200,q=1,boost=self.correction(self.seuil(200),self.cor200)-self.correction(self.seuil(100),self.cor100),type=0)
        self.eq3=EQ(self.eq2,freq=400,q=1,boost=self.correction(self.seuil(400),self.cor400)-self.correction(self.seuil(200),self.cor200),type=0)
        self.eq4=EQ(self.eq3,freq=800,q=1,boost=self.correction(self.seuil(800),self.cor800)-self.correction(self.seuil(400),self.cor400),type=0)
        self.eq5=EQ(self.eq4,freq=1600,q=1,boost=self.correction(self.seuil(1600),self.cor1600)-self.correction(self.seuil(800),self.cor800),type=0)
        self.eq6=EQ(self.eq5,freq=3200,q=1,boost=self.correction(self.seuil(3200),self.cor3200)-self.correction(self.seuil(1600),self.cor1600),type=0)
        self.eq7=EQ(self.eq6,freq=6400,q=1,boost=self.correction(self.seuil(6400),self.cor6400)-self.correction(self.seuil(3200),self.cor3200),type=0)
        self.eq8=EQ(self.eq7,freq=12800,q=1,boost=self.correction(self.seuil(12800),self.cor12800)-self.correction(self.seuil(6400),self.cor6400),type=0)
        self.eq9=EQ(self.eq8,freq=16000,q=1,boost=self.correction(self.seuil(16000),self.cor16000)-self.correction(self.seuil(12800),self.cor12800),type=0)
        

    
    def demarrerServer(self,duplex):
        if duplex==0:
            self.s.reinit(duplex=0)
        else:
            self.s.reinit(duplex=1)
        self.s.start()







    def record(self):
        inp = Input(chnl=0, mul=0.5)
        indel = Delay(inp, delay=0.25, feedback=0.0)
        self.correct(indel)
        self.eq9.out()




    def seuil(self,freq):
        if freq==100:
            return -20
        elif freq==200:
            return -30
        elif freq==400:
            return -60
        elif freq==800:
            return -70
        elif freq==1600:
            return -75
        elif freq==3200:
            return -75
        elif freq==6400:
            return -55
        elif freq==12800:
            return -65
        else:
            return -40


    def correction(self,seuil,seuilEnregistre):
        if (seuilEnregistre-seuil)<0:
            return 0
        else:
            return seuilEnregistre-seuil 
        
            


    def play(self,chemin):
        son=SfPlayer(chemin)
        self.correct(son)
        self.eq9.out()


    def arret(self):
        self.eq9.stop()
            
