try:
    import wx
except ImportError:
    raise ImportError,"The wxPython module is required to run this program"


from pyo import *
#import matplotlib.pyplot as plt
from scipy import *
import parserXml
import FenetrePrinc
import matplotlib.pyplot as plt
import sqlite3
import Erreur
import Audio

fichierXml = parserXml.TransformXmlToPersonnes()
creationXml=parserXml.creerXml()


nom = ' '
pwd = ' '
reglages = [ ]
obj = None
#Tableau q envoyer pour la correction des sons


class reglage():
    freq = None
    db = None


class donnee():
    freq100 = None
    freq200 = None
    freq400 = None
    freq800 = None
    freq1600 = None
    freq3200 = None
    freq6400 = None
    freq12800 = None
    freq16000 = None
    
    db=None
    amplitude = None

  
    
class test(wx.Frame):
    obj = None
    parametre = [ ]
    tableau  = [ ]
    f=100
    s=Server().boot()
    #s.start()
    #db=Sig(0)
    #gain = DBToA(db)
    #sine = Sine(freq=[400,500], mul=0).out()
    
    def __init__(self,parent,id,title):
        
        wx.Frame.__init__(self,parent,id,title,size=(500,500))
        self.parent = parent
        

        message = 'Bienvenue '
        message = message + nom
        message = message + " veuillez prendre part a une serie de Test. \n"
        message = message + " Pour commencer le test veuillez appuyer sur Demarrer. \n"
        message = message + " Pour chaque son augmentez le volume jusqu'a vous entendiez le son puis appuyez sur suivant. \n"
        
        
        panel = wx.Panel(self, -1)
      
        texte = wx.StaticText(panel, -1, message, wx.Point(10, 5), wx.Size(-1, -1))

        
        demarrerButton = wx.Button(panel,-1,"Demarrer", wx.Point(100,200), wx.Size(-1,-1))
        self.Bind(wx.EVT_BUTTON, self.demarrer, demarrerButton)
        
        suivantButton = wx.Button(panel,-1,"Suivant", wx.Point(200, 200), wx.Size(-1, -1))
        self.Bind(wx.EVT_BUTTON, self.suivant, suivantButton)
        
        okButton = wx.Button(panel,-1,"OK", wx.Point(300,200), wx.Size(-1,-1))
        self.Bind(wx.EVT_BUTTON, self.ok, okButton)

        ArretButton = wx.Button(panel,-1,"Pause",wx.Point(400,200),wx.Size(-1,-1))
        self.Bind(wx.EVT_BUTTON, self.arret, ArretButton)
        
        #self.oui = wx.RadioButton(panel, label='Oui',pos=(500,200),style=wx.RB_GROUP)
        #self.non = wx.RadioButton(panel, label = 'Non', pos=(600,200))

        #self.oui.Bind(wx.EVT_RADIOBUTTON, self.SetVal)
        #self.non.Bind(wx.EVT_RADIOBUTTON, self.SetVal)


        ampli = wx.Slider(panel, value = 0, minValue=0, maxValue=120, pos=(130,150), size=(250, -1), style=wx.SL_HORIZONTAL) 
        ampli.Bind(wx.EVT_SCROLL, self.OnSliderScroll)
        
        self.initialize()

    def SetVal(self,e):

        state1 = str(self.oui.GetValue())
        state2 = str(self.non.GetValue())

        self.sb.SetStatusText(state1, 0)
        self.sb.SetStatusText(state2, 1)
        

    def initialize(self):
        self.Show(True)
        

    def OnSliderScroll(self, e):
        
        self.obj = e.GetEventObject()
        test.db = -120 + self.obj.GetValue()
        test.gain = DBToA(Sig(test.db))
        
        test.sine=Sine(freq=test.f, mul=test.gain).out()

    def demarrer(self,event):
        
        test.s.start()
        test.db=-120
        test.gain = DBToA(Sig(test.db))
        
        test.sine=Sine(freq=test.f, mul=test.gain).out()
   
  

    def suivant(self,event):
        self.obj.SetValue(0)
        r = reglage()
        
        r.freq = test.f
        r.db = test.db
        reglages.append(r)
        
        test.parametre.append(test.db)
        #d = donnee()
        test.tableau.append(test.f)
        test.tableau.append(test.db)

        test.db = -120 + self.obj.GetValue()
        test.gain = DBToA(Sig(test.db))
        if (test.f<12800):
            test.f = test.f*2
            test.sine=Sine(freq=test.f, mul=test.gain).out()
        elif(test.f==12800):
            test.f=16000
            test.sine=Sine(freq=test.f, mul=test.gain).out()
        else:
            
            test.sine.stop()
            test.s.stop()
            Erreur.message = " Le Test est fini. Appuyez sur Ok pour voir le resultat"
            appli1 = wx.App()
            frame = Erreur.erreur(None,0,'Erreur')
            appli1.MainLoop()

    def dessinerCourbe(self):
        
        x = [ ]
        y = [ ]
        for i in range(len(test.tableau)//2):
            x.append(test.tableau[2*i])
            y.append(test.tableau[2*i+1])
        plt.plot(x,y)
        plt.show()

    def arret(self,event):
        test.sine.stop()
        
        

    def ok(self,event):

        if (test.f<16000):
            Erreur.message = " Le test n est pas fini"
            appli1 = wx.App()
            frame = Erreur.erreur(None,0,'Erreur')
            appli1.MainLoop()
        else:

            #self.dessinerCourbe()
            tab = creationXml.ajouterPersonne(nom,pwd,test.parametre[0],test.parametre[1],test.parametre[2],test.parametre[3],test.parametre[4],test.parametre[5],test.parametre[6],test.parametre[7],test.parametre[8])
  
        
            fichier = open("personnes.xml","w")
            fichier.write("<quil>\n")
            for i in range(0,len(tab)):
            
                fichier.write("<personne>\n")
                fichier.write("<nom>")
                fichier.write(tab[i].nom)
                fichier.write("</nom>\n ")
                fichier.write("<prenom>")
                fichier.write(tab[i].prenom)
                fichier.write("</prenom>\n")
                fichier.write("<freq100>")
                fichier.write(str(tab[i].freq100))
                fichier.write("</freq100>\n")
                fichier.write("<freq200>")
                fichier.write(str(tab[i].freq200))
                fichier.write("</freq200>\n")
                fichier.write("<freq400>")
                fichier.write(str(tab[i].freq400))
                fichier.write("</freq400>\n")
                fichier.write("<freq800>")
                fichier.write(str(tab[i].freq800))
                fichier.write("</freq800>\n")
                fichier.write("<freq1600>")
                fichier.write(str(tab[i].freq1600))
                fichier.write("</freq1600>\n")
                fichier.write("<freq3200>")
                fichier.write(str(tab[i].freq3200))
                fichier.write("</freq3200>\n")
                fichier.write("<freq6400>")
                fichier.write(str(tab[i].freq6400))
                fichier.write("</freq6400>\n")
                fichier.write("<freq12800>")    
                fichier.write(str(tab[i].freq12800))
                fichier.write("</freq12800>\n")
                fichier.write("<freq16000>")
                fichier.write(str(tab[i].freq16000))
                fichier.write("</freq16000>\n")
                fichier.write("</personne>\n")

            fichier.write("</quil>")
       
            fichier.close()

            
            appli = wx.App()
            frame = Audio.audio(None,0,'Audio')
            appli.MainLoop()
        
        
