#!/usr/bin/python
# -*- coding: iso-8859-1 -*-

try:
    import wx
except ImportError:
    raise ImportError,"The wxPython module is required to run this program"
from scipy import *
import matplotlib.pyplot as plt
import Test
import SoundProcess
from pyo import *


class audio(wx.Frame):
    
    def __init__(self,parent,id,title):
        self.s=None
        wx.Frame.__init__(self,parent,id,title,size=(500,500))
        self.panel = wx.Panel(self, -1)
        sizer = wx.GridBagSizer()
        ButtonChoix = wx.Button(self.panel,-1,"Choisissez un fichier", wx.Point(300,200), wx.Size(-1,-1))
        #ButtonChoix = wx.Button(self,-1,label="Choissez un fichier")
        #sizer.Add(ButtonChoix,(11,12))                
        self.Bind(wx.EVT_BUTTON, self.choix, ButtonChoix)
        ButtonRecord = wx.Button(self.panel,-1,"Corrigez un son en entre", wx.Point(100,200), wx.Size(-1,-1))
        self.Bind(wx.EVT_BUTTON, self.record, ButtonRecord)
        ButtonStop = wx.Button(self.panel,-1,"Stop", wx.Point(200,300), wx.Size(-1,-1))
        self.Bind(wx.EVT_BUTTON, self.arreter, ButtonStop)
        self.cheminFichier=None
        self.traitement=SoundProcess.traitementSon()
        

        self.Show(True)
        self.dessinerCourbe()


    def choix(self,event):
        dlg = wx.FileDialog(self, "Choisissez un fichier",wildcard = "*.*",style = wx.OPEN)
        retour = dlg.ShowModal()
        chemin = dlg.GetPath()
        fichier = dlg.GetFilename()
        self.cheminFichier=fichier
        self.traitement.demarrerServer(0)
        self.traitement.play(chemin)
    def dessinerCourbe(self):
        
        x = [ ]
        y = [ ]
        for i in range(len(Test.reglages)):
            x.append(Test.reglages[i].freq)
            y.append(Test.reglages[i].db)
        plt.plot(x,y)
        plt.show()


    def record(self,event):
        self.traitement.demarrerServer(1)
        self.traitement.record()


    def arreter(self,event):
        self.traitement.arret()
