from xml.dom.minidom import Document
import os


class Personne:
    
    nom = None
    prenom = None
    freq100 = None
    freq200 = None
    freq400 = None
    freq800 = None
    freq1600 = None
    freq3200 = None
    freq6400 = None
    freq12800 = None
    freq16000 = None
    

    def __init__(self):
        pass


class TransformXmlToPersonnes:

    __currentNode__ = None

    __personneList__ = None

    def __init__(self):

        self.readXml()


    def readXml(self):
        from xml.dom.minidom import parse
        self.doc = parse('personnes.xml')


    def getRootElement(self):
        if self.__currentNode__ == None:
            self.__currentNode__ = self.doc.documentElement

        return self.__currentNode__


    def getPersonnes(self):

        if self.__personneList__ != None:

            return self.__personneList__

        self.__personneList__ = []
        
        for personnes in self.getRootElement().getElementsByTagName("personne"):
            
            if personnes.nodeType == personnes.ELEMENT_NODE:

                p = Personne()

                try:
                    
                    p.nom = self.getText(personnes.getElementsByTagName("nom")[0])
                    p.prenom = self.getText(personnes.getElementsByTagName("prenom")[0])
                    p.freq100 = self.getText(personnes.getElementsByTagName("freq100")[0])
                    p.freq200 = self.getText(personnes.getElementsByTagName("freq200")[0])
                    p.freq400 = self.getText(personnes.getElementsByTagName("freq400")[0])
                    p.freq800 = self.getText(personnes.getElementsByTagName("freq800")[0])
                    p.freq1600 = self.getText(personnes.getElementsByTagName("freq1600")[0])
                    p.freq3200 = self.getText(personnes.getElementsByTagName("freq3200")[0])
                    p.freq6400 = self.getText(personnes.getElementsByTagName("freq6400")[0])
                    p.freq12800 = self.getText(personnes.getElementsByTagName("freq12800")[0])
                    p.freq16000 = self.getText(personnes.getElementsByTagName("freq16000")[0])
                    
                    #p.frequenceMax = self.getText(personnes.getElementsByTagName("gain")[0])
                    self.__personneList__.append(p)
                except:
                    print "il y a une erreur"
                
        return self.__personneList__

    def getText(self, node):

        return node.childNodes[0].nodeValue

    def rechercheNom(self,nom):
        tab = self.getPersonnes()
        i=0
        while(i<len(tab) and tab[i].nom != nom):
            i=i+1
        return i<len(tab)

    def nouvelleConnex (self,nom,password):
        tab = self.getPersonnes()
        i=0
        j=0
        while(i<len(tab) and tab[i].nom != nom):
            i=i+1
        if(i<len(tab)):
            return tab[i].prenom == password
        else:
            return False
    
    def personneConnectee(self,nom,password):
        tab = self.getPersonnes()
        i=0
        j=0
        while(i<len(tab) and tab[i].nom != nom):
            i=i+1
        return tab[i]

class creerXml:

    def __init__(self):
        pass

    def ajouterPersonne(self, nom, password, freq100,freq200,freq400,freq800,freq1600,freq3200,freq6400,freq12800,freq16000):
        tab = TransformXmlToPersonnes().getPersonnes()
        
        p = Personne()
        p.nom=nom
        p.prenom=password
        p.freq100=freq100
        p.freq200=freq200
        p.freq400=freq400
        p.freq800=freq800
        p.freq1600=freq1600
        p.freq3200=freq3200
        p.freq6400=freq6400
        p.freq12800=freq12800
        p.freq16000=freq16000
        

        
        tab.append(p)
        return tab
       

            
